// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup PostProcessingGroup
 * \addtogroup PostProcessingGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


// > *** MoReFEM header guards *** //
#ifndef MOREFEM_POSTPROCESSING_POSTPROCESSING_DOT_HPP_
#define MOREFEM_POSTPROCESSING_POSTPROCESSING_DOT_HPP_
// *** MoReFEM header guards *** < //

#include <cstddef> // IWYU pragma: keep
#include <cstdlib> // IWYU pragma: keep
#include <map>
#include <memory>
#include <vector>

#include "Utilities/Filesystem/Directory.hpp" // IWYU pragma: export

#include "Core/NumberingSubset/UniqueId.hpp" // IWYU pragma: export

// IWYU pragma: begin_exports
#include "PostProcessing/Data/DofInformation.hpp"
#include "PostProcessing/Data/TimeIteration.hpp"
#include "PostProcessing/Data/UnknownInformation.hpp"
#include "PostProcessing/File/DofInformationFile.hpp"
#include "PostProcessing/File/InterfaceFile.hpp"
#include "PostProcessing/File/TimeIterationFile.hpp"
#include "PostProcessing/File/UnknownInformationFile.hpp"
// IWYU pragma: end_exports

// ============================
// clang-format off
//! \cond IGNORE_BLOCK_IN_DOXYGEN
// Forward declarations.
// ============================

namespace MoReFEM { class Mesh; }
namespace MoReFEM::FilesystemNS { class File; }

// ============================
// End of forward declarations.
//! \endcond IGNORE_BLOCK_IN_DOXYGEN
// clang-format on
// ============================


namespace MoReFEM::PostProcessingNS
{


    /*!
     * \brief This class is in charge of loading the output files of an MoReFEM simulation and interpret
     * their content, so that output files in any format can be written.
     */
    class PostProcessing final
    {
      public:
        //! Alias to unique pointer.
        using const_unique_ptr = std::unique_ptr<const PostProcessing>;


      public:
        /// \name Special members.
        ///@{

        /*!
         * \brief Constructor.
         *
         * \param[in] data_directory This directory is the one used as output directory by MoReFEM. It must
         * contain the following files:
         * - input_data.lua A copy of the Lua file used in the simulation.
         * - dof_informatio.hhdata Information about all the dofs, required to interpret the raw solution vectors.
         * - solution_****_.hhdata Raw solution vector on processor '#' at time iteration '****'.
         * - time_iteration.hhdata Description of each time iteration and format of the related solution files.
         * If a file named 'filtered_time_iteration.hhdata' is present, it will be sued rather than the
         * time_iteration.hhdata file (such file is generated by FilterTimeIteration script.
         * - unknowns.hhdata List of all unknowns considered.
         * - interfaces.hhdata For all geometric interfaces, the list of Coords that delimit them.
         * - mpi.hhdata The number of processor involved in the simulation (to determine the files to retrieve).
         *
         * Data directory is copied and its beheviour is set to 'read'.
         *
         * \param[in] numbering_subset_id_list List of \a NumberingSubset unique identifiers to consider.
         * \param[in] mesh \a Mesh for which the post-processing is performed.
         *
         */
        explicit PostProcessing(FilesystemNS::Directory data_directory,
                                std::vector<NumberingSubsetNS::unique_id> numbering_subset_id_list,
                                const Mesh& mesh);


        //! Destructor.
        ~PostProcessing() = default;

        //! \copydoc doxygen_hide_copy_constructor
        PostProcessing(const PostProcessing& rhs) = delete;

        //! \copydoc doxygen_hide_move_constructor
        PostProcessing(PostProcessing&& rhs) = delete;

        //! \copydoc doxygen_hide_copy_affectation
        PostProcessing& operator=(const PostProcessing& rhs) = delete;

        //! \copydoc doxygen_hide_move_affectation
        PostProcessing& operator=(PostProcessing&& rhs) = delete;

        ///@}

        //! Get access to the information about unknowns.
        const Data::UnknownInformation::vector_const_shared_ptr& GetExtendedUnknownList() const;

        //! Get access to the information about time iterations.
        const InterpretOutputFilesNS::Data::TimeIteration::vector_const_unique_ptr& GetTimeIterationList() const;

        //! Get access to the mesh.
        const Mesh& GetMesh() const noexcept;

        //! Get the number of processors.
        rank_type Nprocessor() const noexcept;

        //! Get the dof information related to \a processor.
        //! \param[in] numbering_subset_id Unique id of the sought \a NumberingSubset, as returned by
        //! NumberingSubset::GetUniqueId().
        //! \param[in] processor Mpi rank for which the list is generated (on the original computation:
        //! post-processing itself is sequential).
        const Data::DofInformation::vector_const_shared_ptr&
        GetDofInformationList(NumberingSubsetNS::unique_id numbering_subset_id, rank_type processor) const;

        //! Constant accessor to the data included in the interface file.
        const InterfaceFile& GetInterfaceData() const noexcept;

        //! Number of dofs.
        std::size_t Ndof() const noexcept;

        //! Get the dof information related to a given processor and a given numbering subset.
        //! \param[in] numbering_subset_id Unique id of the sought \a NumberingSubset, as returned by
        //! NumberingSubset::GetUniqueId().
        //! \param[in] processor Mpi rank for which the list is generated (on the original computation:
        //! post-processing itself is sequential).
        const DofInformationFile& GetDofFile(NumberingSubsetNS::unique_id numbering_subset_id,
                                             rank_type processor) const;


      private:
        //! Get access to the directory used as output directory by MoReFEM.
        const FilesystemNS::Directory& GetDataDirectory() const noexcept;

        //! Get access to a subdirectory matching the \a numbering_subset_id.
        //! \param[in] rank Mpi rank.
        //! \param[in] numbering_subset_id Unique id of the sought \a NumberingSubset, as returned by
        //! NumberingSubset::GetUniqueId().
        FilesystemNS::Directory GetNumberingSubsetDirectory(rank_type rank,
                                                            NumberingSubsetNS::unique_id numbering_subset_id) const;

        //! Read the interface files (one per rank)  and store its content into the class.
        void ReadInterfaceFiles();

        //! Read the unknown file and store its content into the class.
        void ReadUnknownFile();

        //! Read the time iteration file and store its content into the class.
        void ReadTimeIterationFile();

        //! Read how many processors were involved in the simulation.
        void ReadNprocessor();

        //! Read the dof files (one per processor) and store its content into the class.
        void ReadDofFiles();

        //! Get the unknown file data.
        const UnknownInformationFile& GetUnknownFile() const noexcept;

        //! Get the time iteration file data.
        const InterpretOutputFilesNS::TimeIterationFile& GetTimeIterationFile() const noexcept;

        //! List of \a NumberingSubset for which we want to convert outputs into Ensight format.
        const std::vector<NumberingSubsetNS::unique_id>& GetNumberingSubsetIdList() const noexcept;


      private:
        //! Directory used as output directory by MoReFEM.
        FilesystemNS::Directory data_directory_;

        //! Mesh considered in the problem. \todo #289 Extend to several meshes!
        const Mesh& mesh_;

        //! Number of processors used in the simulation.
        rank_type Nprocessor_;

        //! Interface file data.
        InterfaceFile::const_unique_ptr interface_file_;

        //! Unknown file data.
        UnknownInformationFile::const_unique_ptr unknown_file_;

        //! Time iteration file data.
        InterpretOutputFilesNS::TimeIterationFile::const_unique_ptr time_iteration_file_;

        //! List of \a NumberingSubset for which we want to convert outputs into Ensight format.
        const std::vector<NumberingSubsetNS::unique_id> numbering_subset_id_list_;

        /*!
         * \brief Store here all the information that characterizes a Dof in a given numbering subset.
         *
         * . Key: numbering subset unique id.
         * . Value: Dof file data (one file per processor).
         */
        std::map<NumberingSubsetNS::unique_id, DofInformationFile::vector_unique_ptr>
            dof_file_per_processor_list_per_numbering_subset_;

        //! Total number of dofs.
        std::size_t Ndof_ = 0UL;
    };


    /*!
     * \brief Load in memory the vector which data were written in \a file.
     *
     * This function is very primitive and loads the file as is; for a parallel run what is loaded is just the
     * content of the file for a given processor.
     *
     * \param[in] file File to load.
     *
     * \return Vector read.
     */
    std::vector<double> LoadVector(FilesystemNS::File&& file);


} // namespace MoReFEM::PostProcessingNS


// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup PostProcessingGroup
// *** MoReFEM Doxygen end of group *** < //


#include "PostProcessing/PostProcessing.hxx" // IWYU pragma: export


// > *** MoReFEM end header guards *** //
#endif // MOREFEM_POSTPROCESSING_POSTPROCESSING_DOT_HPP_
// *** MoReFEM end header guards *** < //
